/*$Id: ezmlm-sub.c,v 1.17 1999/01/14 04:01:57 lindberg Exp $*/
/*$Name: ezmlm-idx-0324 $*/
#include "strerr.h"
#include "subscribe.h"
#include "sgetopt.h"
#include "errtxt.h"
#include "scan.h"
#include "idx.h"

#define FATAL "ezmlm-sub: fatal: "

void *psql = (void *) 0;

void die_usage() {
  strerr_die1x(100,
	"ezmlm-sub: usage: ezmlm-sub [-mMsvV] [-h hash] [-n] dir "
		"box@domain [name] ...");
}

int flagname = 0;

void main(argc,argv)
int argc;
char **argv;
{
  char *dir;
  char *addr;
  int opt;
  int flagmysql = 1;	/* use mysql if supported */
  unsigned long forcehash = 0;

  (void) umask(022);
  while ((opt = getopt(argc,argv,"h:HmMnNrRsSvV")) != opteof)
    switch(opt) {
      case 'h': (void) scan_ulong(optarg,&forcehash); break;
      case 'H': forcehash = 0; break;
      case 'm': flagmysql = 1; break;
      case 'M': flagmysql = 0; break;
      case 'n': flagname = 1; break;
      case 'N': flagname = 0; break;
      case 'r': forcehash = 98; break;
      case 'R': forcehash = 0; break;
      case 's': forcehash = 99; break;
      case 'S': forcehash = 0; break;
      case 'v':
      case 'V': strerr_die2x(0,
		"ezmlm-sub version: ezmlm-0.53+",EZIDX_VERSION);
      default:
	die_usage();
    }

  dir = argv[optind++];
  if (!dir) die_usage();

  if (dir[0] != '/')
    strerr_die2x(100,FATAL,ERR_SLASH);

  if (flagname) {
		/* allow repeats and last addr doesn't need comment */
    while ((addr = argv[optind++])) {
      (void) subscribe(dir,addr,1,argv[optind],"+manual",
		flagmysql,(unsigned int) forcehash,FATAL);
      if (!argv[optind++]) break; 
    }
  } else {

    while ((addr = argv[optind++]))
      (void) subscribe(dir,addr,1,"","+manual",flagmysql,
		(unsigned int) forcehash,FATAL);
  }
  closesql();
  _exit(0);
}
